;** Plaqnil.exe
;** 15 dec 2008 - 17 dec 2008
;** MASM32
;** 
;** 8704 bytes

.386
.model flat,stdcall
option casemap:none

include plaqnil.inc

.code

start:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,500
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
	  	invoke IsDialogMessage,hWnd,ADDR msg
	  	.If (!eax)
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		.Endif	
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	LOCAL buffer  :DWORD
	LOCAL bufferQW:QWORD
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		invoke	LoadIcon,hInstance,500
		mov		hIcon,eax
		invoke	SendMessage,hWin,WM_SETICON,NULL,hIcon
		
		invoke GetDlgItem,hWin,1003
		mov		hSB,eax
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_ALG
			invoke MessageBox,hWin,offset dbAlg,SADD("Algoritme"),MB_ICONASTERISK
		.elseif eax==IDM_CREDITS
			invoke MessageBox,hWin,offset dbNotes,SADD("Notes on"),MB_ICONINFORMATION
				
		.elseif eax==1004
			invoke GetDlgItemInt,hWin,1006,NULL,FALSE
			mov	nTABL,eax
			invoke GetDlgItemInt,hWin,1007,NULL,FALSE
			mov	nLEN,eax
			invoke PlaqProc,hWin,nTABL,nLEN
			mov	nMgKgDg,eax

			invoke SendMessage,hSB,SB_SETTEXT,0,NULL
			invoke dwtoa,nMgKgDg,addr buffer			;mgr * 10 -> ascii
			invoke StrToFloat,addr buffer,addr bufferQW	;ascii -> float
			FLD		bufferQW							;float -> coprocessor
			Fidiv	nHON								;float/100
			FST		bufferQW							;store
			invoke FloatToStr,bufferQW,addr buffer		;float -> ascii
			invoke SetDlgItemText,hWin,1008,addr buffer	;ascii -> scherm
			
			.if 	nMgKgDg == 99999
				invoke SendMessage,hSB,SB_SETTEXT,0,addr offlim
			.elseif nMgKgDg >= 650 
				invoke SendMessage,hSB,SB_SETTEXT,0,addr teveel
			.elseif nMgKgDg < 650
				invoke SendMessage,hSB,SB_SETTEXT,0,addr veilig	 	
			.endif
				
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

PlaqProc proc hWin:HWND,nTAB:DWORD,nLE:DWORD

	cmp		nTAB,0		;test input
	jbe		@f			;aantal tabletten
	cmp		nTAB,4		;tussen 
	jae		@f			;1 - 4 dd
	cmp		nLE,99		;lengte
	jbe		@f			;tussen
	cmp		nLE,251		;100 - 250 cm
	jae		@f
	
	mov		eax,nLE		;len
	mul		nLE			;len^2
	mul		nBMI		;len^2 * BMI
	mov		ecx,eax		;tussenuitkomst naar register
	mov		eax,nMGR	;200
	mul		nTAB		;200 x tabl = mgr
	mov		ebx,cE7		;komma-correctiefactor
	mul		ebx			;aantal mgr * correctiefactor
	div		ecx			;gedeeld door len^2 * BMI

	ret
	
@@:	mov		eax,99999	;fake-value 
	ret	

PlaqProc endp

end start
